﻿Public Class GeometricMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        If numbersAsInteger.Count > 0 Then
            Dim p As Integer = numbersAsInteger(0)
            For x As Integer = 1 To numbersAsInteger.GetUpperBound(0)
                p *= numbersAsInteger(x)
            Next
            Return Math.Pow(p, 1 / numbersAsInteger.Count)
        End If
        Return 0
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Geometric mean"
    End Function

End Class
