﻿Public Class InterquartileMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Dim q As Decimal = CDec(numbers.Count / 4)
        Array.Sort(numbersAsInteger)
        If q Mod 1 = 0 Then
            numbersAsInteger = numbersAsInteger.Skip(CInt(q)).Take(numbersAsInteger.Count - CInt(q * 2)).ToArray
            Return numbersAsInteger.Average
        Else
            Dim i As Integer = CInt(Math.Floor(q))
            Dim m As Decimal = CDec(1 - q Mod 1)

            numbersAsInteger = numbersAsInteger.Skip(i).Take(numbersAsInteger.Count - (i * 2)).ToArray
            Dim sum As Decimal = CDec(m * (numbersAsInteger.First + numbersAsInteger.Last))
            numbersAsInteger = numbersAsInteger.Skip(1).Take(numbersAsInteger.Count - 2).ToArray
            sum += numbersAsInteger.Sum
            Return sum / (q * 2)
        End If
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Interquartile mean"
    End Function

End Class
