﻿Public Class Mode
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger() = Array.ConvertAll(numbers, Function(o) CInt(o))
        Dim instances As New Dictionary(Of Integer, Integer)
        For Each n As Integer In numbersAsInteger
            If instances.ContainsKey(n) Then
                instances(n) += 1
            Else
                instances.Add(n, 1)
            End If
        Next

        Dim highest As Integer = instances.Max(Function(kvp) kvp.Value)
        Dim allHighest As New List(Of Integer)

        For Each kvp As KeyValuePair(Of Integer, Integer) In instances
            If kvp.Value = highest Then
                allHighest.Add(kvp.Key)
            End If
        Next

        Return String.Join(", ", allHighest)

    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Mode"
    End Function

End Class
