﻿Public Class WeightedMean
    Implements Strategy

    Public Function computeAverage(numbers() As Object) As Object Implements Strategy.computeAverage
        Dim numbersAsInteger(numbers.Length) As Integer
        Dim weightings(numbers.Length) As Decimal
        Dim sum As Decimal

        For x As Integer = 0 To numbers.GetUpperBound(0)
            Dim parts() As String = numbers(x).ToString.Split(New String() {"   {", "}"}, StringSplitOptions.None)
            numbersAsInteger(x) = CInt(parts(0))
            weightings(x) = CDec(parts(1))
            sum += numbersAsInteger(x) * weightings(x)
        Next

        Return sum / weightings.Sum
    End Function

    Public Overrides Function ToString() As String Implements Strategy.ToString
        Return "Weighted mean"
    End Function

End Class
