﻿Public Class frmMain

    Dim plainNumbers() As Object
    Dim weightedNumbers() As Object
    Dim points() As Object

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ListBox2.Items.Add(New ArithmeticMean)
        ListBox2.Items.Add(New CubicMean)
        ListBox2.Items.Add(New GeneralizedMean)
        ListBox2.Items.Add(New GeometricMean)
        ListBox2.Items.Add(New GeometricMedian)
        ListBox2.Items.Add(New HarmonicMean)
        ListBox2.Items.Add(New InterquartileMean)
        ListBox2.Items.Add(New Median)
        ListBox2.Items.Add(New Midrange)
        ListBox2.Items.Add(New Mode)
        ListBox2.Items.Add(New QuadraticMean)
        ListBox2.Items.Add(New TruncatedMean)
        ListBox2.Items.Add(New WeightedMean)
        ListBox2.Items.Add(New WinsorizedMean)
        Me.KeyPreview = True
        'https://en.wikipedia.org/wiki/Average
    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        If e.KeyCode = Keys.Return Then Button1.PerformClick()
    End Sub

    Private Sub NumericUpDown1_ValueChanged(sender As Object, e As EventArgs) Handles NumericUpDown1.ValueChanged
        Button1.Enabled = NumericUpDown1.Value > 0D
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox1.SelectedIndexChanged
        Button2.Enabled = ListBox1.SelectedIndex > -1
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If ListBox2.SelectedIndex <> 4 AndAlso ListBox2.SelectedIndex <> 12 Then
            ListBox1.Items.Add(NumericUpDown1.Value)
            Label1.Text = ""
            plainNumbers = ListBox1.Items.Cast(Of Object).ToArray
        ElseIf ListBox2.SelectedIndex = 4 Then
            Dim items() As Object = ListBox1.Items.Cast(Of Object).ToArray
            Dim frm As New frmPoints(items)
            If frm.ShowDialog = DialogResult.OK Then
                ListBox1.Items.Clear()
                If frm.ListBox1.Items.Count > 0 Then
                    ListBox1.Items.AddRange(frm.ListBox1.Items.Cast(Of Object).ToArray)
                    points = ListBox1.Items.Cast(Of Object).ToArray
                End If
                Button3.Enabled = ListBox1.Items.Count > 0
            End If
        ElseIf ListBox2.SelectedIndex = 12 Then
            Dim items() As Object = ListBox1.Items.Cast(Of Object).ToArray
            Dim frm As New frmWeights(items)
            If frm.ShowDialog = DialogResult.OK Then
                ListBox1.Items.Clear()
                ListBox1.Items.AddRange(frm.ListBox1.Items.Cast(Of Object).ToArray)
                Button3.Enabled = ListBox1.Items.Count > 0
                weightedNumbers = ListBox1.Items.Cast(Of Object).ToArray
            End If
        End If
    End Sub


    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        ListBox1.Items.RemoveAt(ListBox1.SelectedIndex)
        Label1.Text = ""
        Select Case ListBox2.SelectedIndex
            Case 4
                points = ListBox1.Items.Cast(Of Object).ToArray
            Case 12
                weightedNumbers = ListBox1.Items.Cast(Of Object).ToArray
            Case Else
                plainNumbers = ListBox1.Items.Cast(Of Object).ToArray
        End Select
    End Sub

    Private Sub ListBox2_SelectedIndexChanged(sender As Object, e As EventArgs) Handles ListBox2.SelectedIndexChanged
        Button3.Enabled = ListBox2.SelectedIndex > -1
        Select Case ListBox2.SelectedIndex
            Case 4, 12

            Case Else
                ListBox1.Items.Clear()
                If plainNumbers IsNot Nothing Then
                    ListBox1.Items.AddRange(plainNumbers)
                End If
        End Select
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Dim numbers() As Object = ListBox1.Items.Cast(Of Object).ToArray
        Dim averager As New Averager()
        averager.setStrategy(DirectCast(ListBox2.SelectedItem, Strategy))
        Label1.Text = "The " & ListBox2.Text & " is " & averager.computeAverage(numbers).ToString
    End Sub

    Private Sub ListBox2_MouseDown(sender As Object, e As MouseEventArgs) Handles ListBox2.MouseDown
        If ListBox2.IndexFromPoint(e.Location) = 4 Then
            ListBox1.Items.Clear()
            If points IsNot Nothing Then
                ListBox1.Items.AddRange(points)
            End If
            Dim items() As Object = ListBox1.Items.Cast(Of Object).ToArray
            Dim frm As New frmPoints(items)
            If frm.ShowDialog = DialogResult.OK Then
                ListBox1.Items.Clear()
                If frm.ListBox1.Items.Count > 0 Then
                    ListBox1.Items.AddRange(frm.ListBox1.Items.Cast(Of Object).ToArray)
                    points = ListBox1.Items.Cast(Of Object).ToArray
                End If
                Button3.Enabled = ListBox1.Items.Count > 0
            End If
        ElseIf ListBox2.IndexFromPoint(e.Location) = 12 Then
            ListBox1.Items.Clear()
            If weightedNumbers Is Nothing Then
                If plainNumbers IsNot Nothing Then
                    ListBox1.Items.AddRange(plainNumbers)
                End If
            Else
                ListBox1.Items.AddRange(weightedNumbers)
            End If
            Dim items() As Object = ListBox1.Items.Cast(Of Object).ToArray
            Dim frm As New frmWeights(items)
            If frm.ShowDialog = DialogResult.OK Then
                ListBox1.Items.Clear()
                If frm.ListBox1.Items.Count > 0 Then
                    ListBox1.Items.AddRange(frm.ListBox1.Items.Cast(Of Object).ToArray)
                    weightedNumbers = ListBox1.Items.Cast(Of Object).ToArray
                End If
                Button3.Enabled = ListBox1.Items.Count > 0
            End If
        End If
    End Sub
End Class
